mod Ex03a

incl Mtex

incl Mtexrc

rem 
  \para \bf  3. CVICENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 5.10.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-450-lpi/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane parovacej funkcii 
  a 'course of values recursion'. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 1 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 0 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/1-INF-450-lpi/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 10.10.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Part. Cantor Pairing Function.  \end 

rem 
  \para \bf  Exercise.  \end \header* fun Sum 'Tex_f1_n_sum' \end Show that the 
  summation function \ft Sum(n) \end is primitive recursive. 

fun Sum 'Tex_f1_n_sum'
  Sum(n) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Pair 'Tex_f2_pp_pair' \end Show that 
  the modified Cantor's pairing function \ft Pair(x,y) \end is primitive 
  recursive. 

fun/2 Pair 'Tex_f2_pp_pair'
  Pair(x,y) = Foo

rem 
  \para \bf  Basic properties of the pairing function.  \end We have 
  \eq* 
    Pair(x1,x2) = Pair(y1,y2) -> x1 = y1 & x2 = y2
  \end
  \eq* 
    x < Pair(x,y) & y < Pair(x,y)
  \end
  \eq* 
    x = 0 \/ \e y\e z x = Pair(y,z)
  \end

rem 
  \para \bf  Ordering properties of the pairing function.  \end We have 
  \eq* 
    Pair(x1,x2) <= Pair(y1,y2) <-> x1+x2 < y1+y2 \/ x1+x2 = y1+y2 & x1 <= y1
  \end
  \eq* 
    Pair(x1,x2) < Pair(y1,y2) <-> x1+x2 < y1+y2 \/ x1+x2 = y1+y2 & x1 < y1
  \end

rem 
  \para \bf  Exercise.  \end \header* fun Proj1 'Tex_f1_pp_proj1' \end Show that 
  the first projection \ft Proj1(x) \end of the pairing function is primitive 
  recursive. 

fun Proj1 'Tex_f1_pp_proj1'
  Proj1(x) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Proj2 'Tex_f1_pp_proj2' \end Show that 
  the second projection \ft Proj2(x) \end of the pairing function is primitive 
  recursive. 

fun Proj2 'Tex_f1_pp_proj2'
  Proj2(x) = Foo

rem 
  \para \bf  Exercise.  \end Show that unary iteration of the second projection 
  function is a p.r. function. 

fun/2 Iproj2 'Tex_f2_pp_iproj2'
  Iproj2(n,x) = Foo

rem 
  \para \bf  Exercise.  \end \it  [Uloha (1 bod)]  \end Show that the sequence 
  length function \ft L(x) \end is primitive recursive. 

fun L 
  L(x) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Sub 'Tex_f2_ln_sub' \end Show that 
  the indexing function \ft Sub(x,i) \end is primitive recursive. 

fun/2 Sub 'Tex_f2_ln_sub'
  Sub(x,i) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Fib 'Tex_f1_n_fib' \end Consider the 
  following unary function defined by course of values recursion: 

fun F 'Tex_f1_f_sub'
  F(0) = 0
  F(1) = 1
  F(n+2) = F(n+1)+F(n)+n

rem 
  \para \header* fun G 'Tex_f1_g' \end Derive the function as a p.r. function by 
  showing that the function 
  \eq* 
    G(n) = Pair(F(n),F(n+1))
  \end
  \para is primitive recursive. 

fun G 'Tex_f1_g'
  G(n) = Foo

fun F_is_primrec 'Tex_f1_f_sub'
  F_is_primrec(n) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

rem 
  \para Formats for testing binary functions and predicates. Examples of usage: 
  \items 
   \item \para define \ft Test_fun(x) = H(x)+T(x) \end and run query \it  
         Itf(10)=x:Lf2  \end 
   \item \para define \ft Test_pred(x) <-> H(x) <= T(x) \end and run query \it  
         Itp(10)=x:Lp2  \end 
  \end

loc pred Nn 
  Nn(0)
  Nn(x1,x2) <- N(x1) & N(x2)

loc pred Nnn 
  Nnn(x,y) <- Nn(x) & N(y)

loc pred Lf2 
  Lf2(0)
  Lf2(v,w) <- Nnn(v) & Lf2(w)

loc pred Lp2 
  Lp2(0)
  Lp2(v,w) <- Nn(v) & Lp2(w)

