mod Ex03c

incl Mtex

incl Mtexrc

rem 
  \para \bf  3. CVICENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 5.10.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-450-lpi/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane parovacej funkcii 
  a 'course of values recursion'. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 0 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 1 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/1-INF-450-lpi/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 10.10.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Part. Catalan Pairing Function.  \end See the section \it  3.2 
  Course of Values Recursion  \end in [1]. 

rem 
  \para \bf  Exercise.  \end Show that the Catalan function \ft C(n) \end is 
  primitive recursive. 

fun C 
  C(n) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Sigma 'Tex_f1_pp_sigma' \end Show that 
  the function \ft Sigma(n) \end is primitive recursive. 

fun Sigma 'Tex_f1_pp_sigma'
  Sigma(n) = Foo

rem 
  \para \bf  Exercise.  \end Show that the pair size function \ft |x| \end is 
  primitive recursive. 

fun Szp 'Tex_f1_pp_sz'
  Szp(x) = Foo

rem 
  \para \bf  Exercise.  \end Show that the relative offset function 
  \ft Ro(x) \end is primitive recursive. 

fun Ro 
  Ro(x) = Foo

rem 
  \para \bf  Exercise.  \end 
  \header* fun/2 Convolution 'Tex_f2_pp_convolution' \end Show that the 
  convolution function \ft Convolution(x,z) \end is primitive recursive. 

fun/2 Convolution 'Tex_f2_pp_convolution'
  Convolution(x,z) = Foo

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end 
  \header* fun/2 Pair 'Tex_f2_pp_pair' \end Show that Catalan pairing function 
  \ft Pair(x,y) \end is primitive recursive. 

fun/2 Pair 'Tex_f2_pp_pair'
  Pair(x,y) = Foo

rem 
  \para \bf  Basic properties of Catalan pairing function.  \end We have 
  \eq* 
    Pair(x1,x2) = Pair(y1,y2) -> x1 = y1 & x2 = y2
  \end
  \eq* 
    x < Pair(x,y) & y < Pair(x,y)
  \end
  \eq* 
    x = 0 \/ \e y\e z x = Pair(y,z)
  \end

rem 
  \para \bf  Ordering properties of Catalan pairing function.  \end We have 
  \eq* 
    Pair(x1,x2) < Pair(y1,y2) <-> 
    Szp Pair(x1,x2) < Szp Pair(y1,y2) \/ 
    Szp Pair(x1,x2) = Szp Pair(y1,y2) & (x1 < y1 \/ x1 = y1 & x2 < y2)
  \end

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

rem 
  \para Formats for testing binary functions and predicates. Examples of usage: 
  \items 
   \item \para define \ft Test_fun(x) = H(x)+T(x) \end and run query \it  
         Itf(10)=x:Lf2  \end 
   \item \para define \ft Test_pred(x) <-> H(x) <= T(x) \end and run query \it  
         Itp(10)=x:Lp2  \end 
  \end

loc pred Nn 
  Nn(0)
  Nn(x1,x2) <- N(x1) & N(x2)

loc pred Nnn 
  Nnn(x,y) <- Nn(x) & N(y)

loc pred Lf2 
  Lf2(0)
  Lf2(v,w) <- Nnn(v) & Lf2(w)

loc pred Lp2 
  Lp2(0)
  Lp2(v,w) <- Nn(v) & Lp2(w)

